# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section   free
%define base_name easymock
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           %{base_name}3
Version:        3.0
Release:        2%{?dist}
Epoch:          0
Summary:        Easy mock objects
Group:          Development/Libraries/Java
License:        Apache Software License 2.0
URL:            http://www.easymock.org/
# svn export https://easymock.svn.sourceforge.net/svnroot/easymock/tags/easymock-3.0/ easymock3-3.0/
# tar czf ../SOURCES/easymock3-3.0.tgz easymock3-3.0/

Source0:        easymock3-3.0.tgz
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-settings.xml
Source3:        http://repo1.maven.org/maven2/org/eclipse/osgi/org.eclipse.osgi/3.6.0.v20100517/org.eclipse.osgi-3.6.0.v20100517.jar
Patch0:         easymock3-pom.patch
Patch1:         easymock3-easymock-pom.patch
Patch2:         easymock3-easymock-classextension-pom.patch
Patch3:         easymock3-easymock-integration-pom.patch

BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-pmd
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-skins
BuildRequires:  maven-bundle-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-surefire-provider-junit3
BuildRequires:  mojo-maven2-plugin-findbugs
BuildRequires:  mojo-maven2-plugin-javancss
BuildRequires:  mojo-maven2-plugin-jdepend
BuildRequires:  mojo-parent
BuildRequires:  apache-commons-logging
BuildRequires:  apache-jar-resource-bundle
BuildRequires:  cglib >= 0:2.2
BuildRequires:  eclipse-rcp
BuildRequires:  gmaven
BuildRequires:  gmaven-runtime-1.5
BuildRequires:  groovy16
BuildRequires:  junit4
BuildRequires:  log4j
BuildRequires:  objenesis >= 0:1.1
BuildRequires:  spring-osgi >= 0:1.2
BuildRequires:  spring2-test 
BuildRequires:  slf4j
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
Requires:       java >= 0:1.6.0
Requires:       cglib >= 0:2.2
Requires:       objenesis >= 0:1.1

%description
EasyMock provides Mock Objects for interfaces in JUnit tests by generating 
them on the fly using Java's proxy mechanism. Due to EasyMock's unique style 
of recording expectations, most refactorings will not affect the Mock Objects. 
So EasyMock is a perfect fit for Test-Driven Development.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p ${MAVEN_REPO_LOCAL}/org/eclipse/osgi/org.eclipse.osgi/3.2.2/
ln -s $(ls /usr/lib*/eclipse/plugins/org.eclipse.osgi_3.*.jar) ${MAVEN_REPO_LOCAL}/org/eclipse/osgi/org.eclipse.osgi/3.2.2/org.eclipse.osgi-3.2.2.jar

pushd easymock
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        install 
popd
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        install 
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Daggregate=true \
        site

%install
rm -rf %{buildroot}

install -dm 755 %{buildroot}%{_javadir}
install -m 644 easymock/target/%{base_name}-%{version}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar %{buildroot}%{_javadir}/%{name}.jar
install -m 644 easymock-classextension/target/%{base_name}classextension-%{version}.jar %{buildroot}%{_javadir}/%{name}-classextension-%{version}.jar
ln -s %{name}-classextension-%{version}.jar %{buildroot}%{_javadir}/%{name}-classextension.jar
install -m 644 easymock-integration/target/%{base_name}-integration-%{version}.jar %{buildroot}%{_javadir}/%{name}-integration-%{version}.jar
ln -s %{name}-integration-%{version}.jar %{buildroot}%{_javadir}/%{name}-integration.jar

# pom
install -dm 755 %{buildroot}%{_datadir}/maven2/poms
install -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
%add_to_maven_depmap org.easymock easymock-parent %{version} JPP %{name}-parent
install -m 644 easymock/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.easymock easymock %{version} JPP %{name}
install -m 644 easymock-classextension/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-classextension.pom
%add_to_maven_depmap org.easymock easymock-classextension %{version} JPP %{name}-classextension
install -m 644 easymock-integration/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-integration.pom
%add_to_maven_depmap org.easymock easymock-integration %{version} JPP %{name}-integration

# javadoc
install -dm 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -p -m 644 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
sed -i s/@VERSION@/%{version}-brew/g %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/easymock.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/easymock.pom
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc easymock/LICENSE.txt
%{_javadir}/%{name}*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}


%changelog
* Mon Jun 18 2012 Ralph Apel <r.apel@r-apel.de> 0:3.0-2
- Avoid FileDigest and PayloadIsXz problems on EL5

* Mon Jun 04 2012 Ralph Apel <r.apel@r-apel.de> 0:3.0-1
- 3.0 as easymock3

* Mon Nov 02 2009 David Walluck <dwalluck@redhat.com> 0:2.5.2-2
- copy pom to repolib

* Wed Sep 30 2009 David Walluck <dwalluck@redhat.com> 0:2.5.2-1
- 2.5.2

* Mon Jul 20 2009 David Walluck <dwalluck@redhat.com> 0:2.4-3
- fix component-info.xml

* Thu Jun 25 2009 Yong Yang <yyang@redhat.com> 0:2.4-2
- Change to BR jpackage-utils >= 0:1.7.3

* Wed May 20 2009 David Walluck <dwalluck@redhat.com> 0:2.4-1
- 2.4
- add repolib

* Wed Jun 25 2008 Ralph Apel <r.apel at r-apel.de> - 0:2.3-1.jpp5
- 2.3, built with maven2
- Add pom and depmap frag

* Fri Feb 24 2006 Ralph Apel <r.apel at r-apel.de> - 0:2.0-1jpp
- Update to 2.0 requiring java-1.5 for JPP-5.0

* Fri Feb 24 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.2-1jpp
- Update to 1.2 keeping only java 1.4 requirement

* Fri Feb 24 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.1-3jpp
- drop java-1.3.1 requirement

* Mon Oct 04 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.1-2jpp
- Fixed Url, Summary, Description and License

* Mon Oct 04 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.1-1jpp
- First JPackage release
